#
# Conditional build:
%bcond_with	context		# enable Boost Context [gas+PE combination not supported]
#
%define		realname	boost
Summary:	The Boost C++ Libraries - MinGW32 cross version
Summary(pl.UTF-8):	Biblioteki C++ "Boost" - wersja skrośna dla MinGW32
Name:		crossmingw32-%{realname}
Version:	1.55.0
%define	fver	%(echo %{version} | tr . _)
Release:	1
License:	Boost Software License and others
Group:		Development/Libraries
Source0:	http://downloads.sourceforge.net/boost/%{realname}_%{fver}.tar.bz2
# Source0-md5:	d6eef4b4cacb2183f2bf265a5a03a354
URL:		http://www.boost.org/
BuildRequires:	crossmingw32-bzip2
BuildRequires:	crossmingw32-gcc-c++
BuildRequires:	crossmingw32-runtime
BuildRequires:	crossmingw32-w32api
BuildRequires:	crossmingw32-zlib
Requires:	crossmingw32-bzip2
Requires:	crossmingw32-runtime
Requires:	crossmingw32-zlib
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		no_install_post_strip	1

%define		target		i386-mingw32
%define		target_platform	i386-pc-mingw32

%define		_sysprefix	/usr
%define		_prefix		%{_sysprefix}/%{target}
%define		_libdir		%{_prefix}/lib
%define		_dlldir		/usr/share/wine/windows/system

%define		__cc		%{target}-gcc
%define		__cxx		%{target}-g++

%ifnarch %{ix86}
# arch-specific flags (like alpha's -mieee) are not valid for i386 gcc
%define		optflags	-O2
%endif
# -z options are invalid for mingw linker, most of -f options are Linux-specific
%define		filterout_ld	-Wl,-z,.*
%define		filterout_c	-f[-a-z0-9=]*
%define		filterout_cxx	-f[-a-z0-9=]*

%define		abi_tag		1_55

%description
The Boost web site provides free peer-reviewed portable C++ source
libraries. The emphasis is on libraries which work well with the C++
Standard Library. One goal is to establish "existing practice" and
provide reference implementations so that the Boost libraries are
suitable for eventual standardization. Some of the libraries have
already been proposed for inclusion in the C++ Standards Committee's
upcoming C++ Standard Library Technical Report.

%description -l pl.UTF-8
Strona http://www.boost.org/ dostarcza darmowe biblioteki C++ wraz z
kodem źródłowym. Nacisk położono na biblioteki, które dobrze
współpracują ze standardową biblioteką C++. Celem jest ustanowienie
"istniejącej praktyki" i dostarczenie implementacji, tak że biblioteki
"Boost" nadają się do ewentualnej standaryzacji. Niektóre z bibliotek
już zostały zgłoszone do komitetu standaryzacyjnego C++ w nadchodzącym
Raporcie Technicznym Biblioteki Standardowej C++.

%package static
Summary:	Static Boost libraries (cross MinGW32 version)
Summary(pl.UTF-8):	Statyczne biblioteki Boost (wersja skrośna MinGW32)
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description static
Static Boost libraries (cross MinGW32 version).

%description static -l pl.UTF-8
Statyczne biblioteki Boost (wersja skrośna MinGW32).

%package dll
Summary:	Boost - DLL libraries for Windows
Summary(pl.UTF-8):	Boost - biblioteki DLL dla Windows
Group:		Applications/Emulators
Requires:	crossmingw32-bzip2-dll
Requires:	crossmingw32-zlib-dll
Requires:	wine

%description dll
Boost - DLL libraries for Windows.

%description dll -l pl.UTF-8
Boost - biblioteki DLL dla Windows.

%prep
%setup -q -n %{realname}_%{fver}

echo 'using gcc : : %{target}-g++ : ' \
	'<cxxflags>"%{rpmcxxflags}"' \
	'<archiver>%{target}-ar' \
	'<rc>%{target}-windres ;' >tools/build/v2/user-config.jam

# use Windows Message Compiler, not Midnight Commander
%{__sed} -i -e 's,mc $(MCFLAGS),%{target}-windmc $(MCFLAGS),' tools/build/v2/tools/mc.jam

%build
./bootstrap.sh --prefix=%{_prefix}
./b2 \
	-d2 \
	%{_smp_mflags} \
	-sBZIP2_BINARY=bzip2 \
	--layout=versioned \
	%{!?with_context:--without-context --without-coroutine} \
	--without-python \
	--without-test \
	debug-symbols=on \
	inlining=on \
	link=static,shared \
	target-os=windows \
	threadapi=win32 \
	threading=multi \
	toolset=gcc \
	variant=release

%if 0%{!?debug:1}
%{target}-strip stage/lib/*.dll
%{target}-strip -g -R.comment -R.note stage/lib/*.a
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_includedir},%{_libdir},%{_dlldir}}

cp -r boost $RPM_BUILD_ROOT%{_includedir}
cp -a stage/lib/*.a $RPM_BUILD_ROOT%{_libdir}
install stage/lib/*.dll $RPM_BUILD_ROOT%{_dlldir}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%{_libdir}/libboost_atomic-mgw*-mt-%{abi_tag}.dll.a
%{_libdir}/libboost_chrono-mgw*-mt-%{abi_tag}.dll.a
%{?with_context:%{_libdir}/libboost_context-mgw*-mt-%{abi_tag}.dll.a}
%{?with_context:%{_libdir}/libboost_coroutine-mgw*-mt-%{abi_tag}.dll.a}
%{_libdir}/libboost_date_time-mgw*-mt-%{abi_tag}.dll.a
%{_libdir}/libboost_filesystem-mgw*-mt-%{abi_tag}.dll.a
%{_libdir}/libboost_graph-mgw*-mt-%{abi_tag}.dll.a
%{_libdir}/libboost_iostreams-mgw*-mt-%{abi_tag}.dll.a
%{_libdir}/libboost_locale-mgw*-mt-%{abi_tag}.dll.a
%{_libdir}/libboost_log-mgw*-mt-%{abi_tag}.dll.a
%{_libdir}/libboost_log_setup-mgw*-mt-%{abi_tag}.dll.a
%{_libdir}/libboost_math_c99-mgw*-mt-%{abi_tag}.dll.a
%{_libdir}/libboost_math_c99f-mgw*-mt-%{abi_tag}.dll.a
%{_libdir}/libboost_math_c99l-mgw*-mt-%{abi_tag}.dll.a
%{_libdir}/libboost_math_tr1-mgw*-mt-%{abi_tag}.dll.a
%{_libdir}/libboost_math_tr1f-mgw*-mt-%{abi_tag}.dll.a
%{_libdir}/libboost_math_tr1l-mgw*-mt-%{abi_tag}.dll.a
%{_libdir}/libboost_program_options-mgw*-mt-%{abi_tag}.dll.a
%{_libdir}/libboost_random-mgw*-mt-%{abi_tag}.dll.a
%{_libdir}/libboost_regex-mgw*-mt-%{abi_tag}.dll.a
%{_libdir}/libboost_serialization-mgw*-mt-%{abi_tag}.dll.a
%{_libdir}/libboost_signals-mgw*-mt-%{abi_tag}.dll.a
%{_libdir}/libboost_system-mgw*-mt-%{abi_tag}.dll.a
%{_libdir}/libboost_thread_win32-mgw*-mt-%{abi_tag}.dll.a
%{_libdir}/libboost_timer-mgw*-mt-%{abi_tag}.dll.a
%{_libdir}/libboost_wave-mgw*-mt-%{abi_tag}.dll.a
%{_libdir}/libboost_wserialization-mgw*-mt-%{abi_tag}.dll.a
# static-only
%{_libdir}/libboost_exception-mgw*-mt-%{abi_tag}.a
%{_includedir}/boost

%files static
%defattr(644,root,root,755)
%{_libdir}/libboost_atomic-mgw*-mt-%{abi_tag}.a
%{_libdir}/libboost_chrono-mgw*-mt-%{abi_tag}.a
%{?with_context:%{_libdir}/libboost_context-mgw*-mt-%{abi_tag}.a}
%{?with_context:%{_libdir}/libboost_coroutine-mgw*-mt-%{abi_tag}.a}
%{_libdir}/libboost_date_time-mgw*-mt-%{abi_tag}.a
%{_libdir}/libboost_filesystem-mgw*-mt-%{abi_tag}.a
%{_libdir}/libboost_graph-mgw*-mt-%{abi_tag}.a
%{_libdir}/libboost_iostreams-mgw*-mt-%{abi_tag}.a
%{_libdir}/libboost_locale-mgw*-mt-%{abi_tag}.a
%{_libdir}/libboost_log-mgw*-mt-%{abi_tag}.a
%{_libdir}/libboost_log_setup-mgw*-mt-%{abi_tag}.a
%{_libdir}/libboost_math_c99-mgw*-mt-%{abi_tag}.a
%{_libdir}/libboost_math_c99f-mgw*-mt-%{abi_tag}.a
%{_libdir}/libboost_math_c99l-mgw*-mt-%{abi_tag}.a
%{_libdir}/libboost_math_tr1-mgw*-mt-%{abi_tag}.a
%{_libdir}/libboost_math_tr1f-mgw*-mt-%{abi_tag}.a
%{_libdir}/libboost_math_tr1l-mgw*-mt-%{abi_tag}.a
%{_libdir}/libboost_program_options-mgw*-mt-%{abi_tag}.a
%{_libdir}/libboost_random-mgw*-mt-%{abi_tag}.a
%{_libdir}/libboost_regex-mgw*-mt-%{abi_tag}.a
%{_libdir}/libboost_serialization-mgw*-mt-%{abi_tag}.a
%{_libdir}/libboost_signals-mgw*-mt-%{abi_tag}.a
%{_libdir}/libboost_system-mgw*-mt-%{abi_tag}.a
%{_libdir}/libboost_thread_win32-mgw*-mt-%{abi_tag}.a
%{_libdir}/libboost_timer-mgw*-mt-%{abi_tag}.a
%{_libdir}/libboost_wave-mgw*-mt-%{abi_tag}.a
%{_libdir}/libboost_wserialization-mgw*-mt-%{abi_tag}.a

%files dll
%defattr(644,root,root,755)
%{_dlldir}/libboost_atomic-mgw*-mt-%{abi_tag}.dll
%{_dlldir}/libboost_chrono-mgw*-mt-%{abi_tag}.dll
%{?with_context:%{_libdir}/libboost_context-mgw*-mt-%{abi_tag}.dll}
%{?with_context:%{_libdir}/libboost_coroutine-mgw*-mt-%{abi_tag}.dll}
%{_dlldir}/libboost_date_time-mgw*-mt-%{abi_tag}.dll
%{_dlldir}/libboost_filesystem-mgw*-mt-%{abi_tag}.dll
%{_dlldir}/libboost_graph-mgw*-mt-%{abi_tag}.dll
%{_dlldir}/libboost_iostreams-mgw*-mt-%{abi_tag}.dll
%{_dlldir}/libboost_locale-mgw*-mt-%{abi_tag}.dll
%{_dlldir}/libboost_log-mgw*-mt-%{abi_tag}.dll
%{_dlldir}/libboost_log_setup-mgw*-mt-%{abi_tag}.dll
%{_dlldir}/libboost_math_c99-mgw*-mt-%{abi_tag}.dll
%{_dlldir}/libboost_math_c99f-mgw*-mt-%{abi_tag}.dll
%{_dlldir}/libboost_math_c99l-mgw*-mt-%{abi_tag}.dll
%{_dlldir}/libboost_math_tr1-mgw*-mt-%{abi_tag}.dll
%{_dlldir}/libboost_math_tr1f-mgw*-mt-%{abi_tag}.dll
%{_dlldir}/libboost_math_tr1l-mgw*-mt-%{abi_tag}.dll
%{_dlldir}/libboost_program_options-mgw*-mt-%{abi_tag}.dll
%{_dlldir}/libboost_random-mgw*-mt-%{abi_tag}.dll
%{_dlldir}/libboost_regex-mgw*-mt-%{abi_tag}.dll
%{_dlldir}/libboost_serialization-mgw*-mt-%{abi_tag}.dll
%{_dlldir}/libboost_signals-mgw*-mt-%{abi_tag}.dll
%{_dlldir}/libboost_system-mgw*-mt-%{abi_tag}.dll
%{_dlldir}/libboost_thread_win32-mgw*-mt-%{abi_tag}.dll
%{_dlldir}/libboost_timer-mgw*-mt-%{abi_tag}.dll
%{_dlldir}/libboost_wave-mgw*-mt-%{abi_tag}.dll
%{_dlldir}/libboost_wserialization-mgw*-mt-%{abi_tag}.dll
%changelog
* Sat Feb 08 2014 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/crossmingw32-boost.git;a=log;h=master

* Fri Feb 07 2014 Jakub Bogusz <qboosh@pld-linux.org> b184e0d
- pass mingw32 windres as Windows Resource Compiler

* Tue Feb 04 2014 Jakub Bogusz <qboosh@pld-linux.org> 8571d93
- updated to 1.55.0
- serialization library now builds without hacks
- log library requires hacking mc tool name
- coroutine library disabled (requires context)

* Sat Jun 15 2013 Jakub Bogusz <qboosh@pld-linux.org> 320e1cc
- use _smp_mflags instead of __jobs (the latter might be defined as empty, leading to b2 syntax error)
- list libraries explicitly; moved static-only libboost_exceptions to base

* Mon Jun 10 2013 Łukasz Krotowski <lkrotowski@pld-linux.org> ac7c108
- updated to 1.53.0
- disabled Boost.Context (problems with cross compilation)
- added parallel build

* Wed Sep 29 2010 Łukasz Krotowski <lkrotowski@pld-linux.org> a8f548c
- obsoleted wineprefixcreate replaced

* Tue Sep 21 2010 Jakub Bogusz <qboosh@pld-linux.org> 3ea966e
- updated to 1.44.0
- removed obsolete win patch

* Thu Jan 21 2010 Łukasz Krotowski <lkrotowski@pld-linux.org> f8be5c0
- up to 1.41

* Fri Feb 27 2009 Jakub Bogusz <qboosh@pld-linux.org> 05fa162
- updated to 1.38.0

* Fri Nov 07 2008 Jakub Bogusz <qboosh@pld-linux.org> fec8977
- updated to 1.37.0
- updated win patch

* Fri Nov 07 2008 Jakub Bogusz <qboosh@pld-linux.org> 84edd89
- updated for 1.37.0

* Fri Sep 12 2008 Łukasz Krotowski <lkrotowski@pld-linux.org> d97fa3b
- conditionally enable Boost Serialization (requires wine for building)

* Fri Sep 12 2008 Łukasz Krotowski <lkrotowski@pld-linux.org> a27a3b7
- wide char serialization disabled on mingw32

* Thu Sep 11 2008 Jakub Bogusz <qboosh@pld-linux.org> 321d21f
- cleanup
- separated -static

* Fri Sep 05 2008 Łukasz Krotowski <lkrotowski@pld-linux.org> ff36f43
- rel 1 (builds, seems to work)
- using boost way for configuration (dropped perl hackery)
- dropped some more sed hackery
- using boost way for linking (dropped custom script)
- using boost naming scheme (with version and compiler)

* Fri Sep 05 2008 Łukasz Krotowski <lkrotowski@pld-linux.org> 8e7826e
- disabled default -O3 optimization
- used proper library prefix and suffix
- disabled conflicting math routine

* Sat Aug 23 2008 Jakub Bogusz <qboosh@pld-linux.org> 8d134d9
- up to 1.36.0; still doesn't build
- updated win patch

* Sat Aug 23 2008 Jakub Bogusz <qboosh@pld-linux.org> 9bb5db3
- updated for 1.36.0

* Tue May 13 2008 Jakub Bogusz <qboosh@pld-linux.org> 0826927
- at least compiles now; dll hacks need some more inter-library deps though

* Tue May 13 2008 Jakub Bogusz <qboosh@pld-linux.org> c66a904
- started update to 1.35.0
- updated win patch
- unified cross stuff
- avoid touching every single file in sources

* Tue May 13 2008 Jakub Bogusz <qboosh@pld-linux.org> a8d8c60
- updated for 1.35.0

